@echo off
rem CRYSFIRE - Use CRYS934 (currently v9.34a) to launch a targeted indexing run
rem R.Shirley, 5Jun00

rem ** If this fails to run, reporting "out of environment space", you have
rem    probably already used up most of your environment allocation, and so
rem    need to increase this to e.g. 1024 or 2048 bytes, using the SHELL
rem    command in CONFIG.SYS (/e parameter - e.g. /e:2048 for 2048 bytes)
rem
rem    Thus to provide 2048 bytes of environment space, insert the one of the
rem    following "shell=" lines in your CONFIG.SYS file, as appropriate:
rem
rem    (Windows 95)   shell=C:\WINDOWS\COMMAND.COM C:\WINDOWS /e:2048 /p
rem    (Windows 3.1)  shell=C:\COMMAND.COM C:\DOS /e:2048 /p

if (%1) == (/?) goto usage
if (%1) == (/h) goto usage
if (%1) == (-?) goto usage
if (%1) == (-h) goto usage
if (%1) == (?) goto usage
if (%1) == (h) goto usage
rem First delete any existing _SETPARM.BAT file
if exist _SETPARM.BAT del _SETPARM.BAT

CRYS934

rem exit silently if no parameter file was written
if not exist _SETPARM.BAT goto endbat
rem Set environmental variables via BAT file written by CRYS934, since
rem the ENVIRON statement in QBasic gives spurious "Out of memory" errors
call _SETPARM
del _SETPARM.BAT

rem From v9.33b (23Jun99), use one parameterised launcher based on QDAT input
rem filenames targeted via _C2Qid, instead of separate ones for each target
if (%_C2Qid%) == () goto no_targ
if not exist %_C2Qdset%.Q%_C2Qid% goto no_data

call Q2%_C2Qid% %_C2Qdset%
echo Indexing-target script finished
goto exit

:no_targ
echo No indexing target requested
goto exit
:no_data
echo Can't find the targeted QDAT input data file %_C2Qdset%.Q%_C2Qid%
goto exit

:usage
echo CRYSFIRE System - A powder-indexing wizard constructed from scripts and
echo                   programs by Robin Shirley, using CRYS as a front-end
echo.
echo No parameters are needed (except ? or h to see this help information).
echo.
echo 1)  Type CRYSFIRE, then load your data (LO) into CRYS.
echo.
echo 2)  Optionally carry out data-enhancement using self-calibration (SC), etc.
echo     Then save (SA), specifying QDAT (Q) format and the target indexing
echo     program(s) of your choice - advice and defaults are provided for their
echo     controls and parameters.
echo.
echo 3)  Quit CRYS with the QU command, then press ENTER to return to the system.
echo.
echo 4)  From this point the indexing run (for the last target program selected)
echo     will proceed completely automatically, leaving you looking at its short
echo     output file in an editor of your choice (default = MSDOS EDIT).
echo.
echo 5)  When you have finished looking at this, exit (alt-F,X if using EDIT).
echo     You will then be shown the updated solutions-summary file for this dataset,
echo     sorted into descending order of first I20 (indexed lines in the first 20),
echo     then on figure of merit.  Again type alt-F,X to exit and end the run.
echo.
pause
echo If you saved QDAT input files for additional target indexing programs at
echo stage 2 above, launch them in turn using the appropriate Q2{indx} scripts,
echo (e.g. Q2IT, Q2DV, Q2TR, Q2KL, Q2LZ, etc.).  Usage information on
echo them can be obtained by just typing their names without parameters.
echo.
echo ** If CRYSFIRE fails to run, reporting "out of environment space", you have
echo    probably already used up most of your environment allocation, and so
echo    need to increase this to e.g. 1024 or 2048 bytes, using the SHELL
echo    command in CONFIG.SYS (/e parameter - e.g. /e:2048 for 2048 bytes)
echo.
echo    Thus to provide 2048 bytes of environment space, insert the one of the
echo    following "shell=" lines in your CONFIG.SYS file, as appropriate:
echo.
echo    (Windows 95)   shell=C:\WINDOWS\COMMAND.COM C:\WINDOWS /e:2048 /p
echo    (Windows 3.1)  shell=C:\COMMAND.COM C:\DOS /e:2048 /p
echo.
echo For more information on CRYSFIRE and its associated scripts and programs,
echo see the user's manual for the system in CRYSFIRE.DOC (MS Word 6 format).
goto endbat
:exit
echo End of CRYSFIRE run
:endbat
echo.
set _C2Qdset=
set _C2Qid=
