@echo off
echo.
if (%1) == () cls
echo MERGESUM - Merges the CRYSFIRE summary files for two different dataset names,
echo            leaving the resulting merged summary optionally in a third file.
echo.
set _Sdate=19Jul99
if (%1) == () goto usage
set _dset1=%1
echo Dataset 1 is %_Dset1%
if not (%2) == () goto chk_ds2
echo ** Second dataset name has not been specified - can't proceed with run
echo (for usage information, type MERGESUM without any dataset names)
goto end

:chk_ds2
set _dset2=%2
echo Dataset 2 is %_Dset2%
set _dest=%2
if not (%3) == () set _dest=%3
echo Destination dataset for merged summary is %_dest%
echo.

:merge
rem Copy the 2 run-summaries to temporary file MERGESUM.$$1
if exist MERGESUM.$$1 del MERGESUM.$$1 >nul
copy %_dset1%.SUM+%_dset2%.SUM MERGESUM.$$1 >nul
if exist MERGESUM.$$1 goto sort
echo ** Can't find temporary destination file MERGESUM.$$1 after COPY operation
goto end

:sort
rem Sort the combined dataset-summary into descending order of I20 & Merit
rem in second temporary file MERGESUM.%%2
sort /R <MERGESUM.$$1 >MERGESUM.$$2
if exist MERGESUM.$$2 goto vratio
echo ** Can't find temporary destination file MERGESUM.$$2 after SORT operation
goto end

:vratio
rem Use program VRATIO to update the V/V1 ratios in the sorted summary, based
rem on the volume now in record one, leaving the result in %_dest%.SUM
if not exist MERGESUM.$$2 goto end
VRATIO MERGESUM.$$2 %_dest%.SUM >nul
if exist %_dest%.SUM goto mk_head
echo ** Can't find destination file %_dest%.SUM after VRATIO calculations
goto end

:mk_head
echo Merge completed
echo.
rem Create a header in HEADINGS.SUM for a headed version in %_dest%.SMH
del MERGESUM.$$? >nul
if exist %_dest%.SMH del %_dest%.SMH >nul
rem Use program QHEAD to generate headings file HEADINGS.SUM, so that
rem HEADINGS.SUM need not be copied beforehand into the current directory
QHEAD >nul
rem HEADINGS.SUM should now be present, but its existence tests have been
rem kept anyway, in case of problems
if exist HEADINGS.SUM goto add_head
echo (Merged summary created in %_dest%.SUM, but couldn't find HEADINGS.SUM
echo after running QHEAD, to make a headed version in %_dest%.SMH.
goto disp_SUM

:add_head
copy HEADINGS.SUM+%_dest%.SUM %_dest%.SMH >nul
if exist %_dest%.SMH goto disp
echo (Merged summary created in %_dest%.SUM, and a summary-header in
echo HEADINGS.SUM, but then couldn't find the resulting headed version.
echo in %_dest%.SMH after COPY operation.

:disp_SUM
echo The merged summary will thus be displayed without headings.)
echo.
goto disp

:disp
if (%INDEXEDIT%) == (NONE) goto end
set _EXT=SUM
if exist %_dest%.SMH set _EXT=SMH
echo The merged %_dest%.%_EXT% summary file will now be displayed in an editor
pause
set INDXED=%INDEXEDIT%
if (%INDXED%) == () set INDXED=edit
%INDXED% %_dest%.%_EXT%
set INDXED=
set _EXT=
if exist HEADINGS.SUM del HEADINGS.SUM >nul
goto end

:usage
echo Only the .SUM files are merged, since their one-line records are easy to
echo sort automatically (if you also want to merge the corresponding LOG files
echo bringing the different run-logs into overall chronological order, you'll
echo have to do this by hand-editing)
echo.
echo The V1/V ratios are also recalculated, based on the volume for the solution
echo now at the top of the sorted list.
echo.
pause
echo usage    MERGESUM {dset1} {dset2}
echo    or    MERGESUM {dset1} {dset2} {dest}
echo.
echo          where {dset1} and {dset2} are the base names of the two summary
echo                files to be merged (without their .SUM extensions)
echo.
echo          and   {dest} is an optional destination name for the resulting
echo                merged dataset summary file (i.e. {dest}.SUM)
echo.
echo   If {dest} isn't specified, the merged summary is written to {dset2}.SUM
echo.
echo   A headed summary file {dset2}.SMH or {dest}.SMH is also created.  This
echo   is then displayed using the editor specified in environmental variable
echo   INDEXEDIT (default: MSDOS EDIT).
echo.
echo   R.Shirley, %_Sdate%

:end
echo.
set _Sdate=
set _dest=
set _dset2=
set _dset1=
